<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html>
<html>
 <head>
     <%@include file="/WEB-INF/secured/header.jsp" %>
    <meta content="text/html" http-equiv="Content-Type" />
    <title></title>
    <meta name="keywords" content="" />
    <meta name="description" content="" />
    <link rel="stylesheet" href="<%=request.getContextPath()%>/css/style.css" type="text/css" media="screen, projection" />
    <link rel="stylesheet" href="<%=request.getContextPath()%>/css/jRating.jquery.css" type="text/css" />
    <link rel="stylesheet" href="<%=request.getContextPath()%>/css/menu.css" type="text/css" />
    <script type="text/javascript" src="<%=request.getContextPath()%>/js/jRating.jquery.js"></script>
    <script src="<%=request.getContextPath()%>/js/menu.js"></script>
    <script src="<%=request.getContextPath()%>/js/home/home.js"></script>
 </head>

 <body>
        <div class="header">
            <div class="logo">
                <h1><a href="http://">LOGO</a></h1>
            </div>
            <div id="menu" class="menu">
                <ul>
                    <li><a href="#">Home</a></li>
					<li><a href="<%=request.getContextPath()%>/rest/articles/list">Articles</a></li>
					<li><a href="<%=request.getContextPath()%>/rest/categories/list">Categories</a></li>
					<li><a href="#">Reading List</a></li>
					<li><a href="#">History</a></li>
                </ul>
            </div>
            <div class="block_right">
                <ul>
                	<li class="search">
                        <form class="search_form" method="get" action=""> 
                            <input type="text" class="placeholder_search" placeholder="search" value="" />
                            <input type="submit" class="submit" value="Search" /> 
                        </form>
                    </li>
                	<li>
                        <ul class="user_nam">
                        	<li><a href="http://">user name</a></li>
                        	<li class="avatar"></li>
                        </ul>
                    </li>
                </ul>
            </div>
        </div>
        <div class="paginationContainerTop">
        <span class="paginationLink">
              <span class="left paginationInfo">
                  <c:out value="${it.pagination.start+1}"/> -
                  <c:out value="${it.pagination.start+it.pagination.limit}"/>
                  &nbsp; of <c:out value="${it.total}"/> &nbsp;&nbsp; Articles
              </span>
              <span class="right">
				  <c:if test="${it.pagination.start!=0}">
					<a href="<%=request.getContextPath()%>/rest/articles/list?limit=${it.pagination.limit}&start=${it.pagination.start-it.pagination.limit}">&nbsp;Prev&nbsp;&nbsp;</a>
				  </c:if>
				  <c:if test="${it.total-it.pagination.start-it.pagination.limit>0}">	
					<a href="<%=request.getContextPath()%>/rest/articles/list?limit=${it.pagination.limit}&start=${it.pagination.start+it.pagination.limit}">&nbsp;&nbsp;Next&nbsp;</a>
			      </c:if>
			 </span>
        </span>
        </div>
        <div class="paginationContainer">
            <table class="results">
              <tbody>
               <c:forEach var="articles" varStatus="rowCounter" items="${it.articles}"  begin="0">
                    <c:choose>
				          <c:when test="${rowCounter.count % 2 == 0}">
				           	 <tr class="even detailed">
			                     <td class="number"><c:out value="${it.pagination.start + rowCounter.count}"/>.</td>
			                     <td class="title">
			                       <a href="#">${articles.title}</a>
			                       <div class="outline">
			                            <c:forEach var="category" items="${articles.categories}" >
                                          <a href="<%=request.getContextPath()%>/rest/categories/home?categoryId=${category.objectId}">${category.name}</a>&nbsp;&nbsp;
                                        </c:forEach>
			                       </div>
				                     <ul class="article">
			                        	<li class="left">
			                                <ul class="like">
			                                        	<li class="facebook"><span>1.5k</span></li>
			                                        	<li class="twitter"><span>&ensp;900</span></li>
			                                        	<li class="github"><span>10</span></li>
			                                </ul>
			                            </li>
			                            <li class="read">
			                                <p><a href="<%=request.getContextPath()%>/rest/articles/html">Read</a></p>
			                                <span><a href="http://">Save for Later</a></span>
			                            </li>
			                        </ul>
			                      </td>			                      
		                   </tr>
				          </c:when>
				          <c:otherwise>
				            <tr class="odd detailed">
			                     <td class="number"><c:out value="${it.pagination.start + rowCounter.count}"/>.</td>
			                     <td class="title">
			                       <a href="#">${articles.title}</a>
			                       <div class="outline">
			                            <c:forEach var="category" items="${articles.categories}" >
                                          <a href="<%=request.getContextPath()%>/rest/categories/home?categoryId=${category.objectId}">${category.name}</a>&nbsp;&nbsp;
                                        </c:forEach>
			                       </div>
				                     <ul class="article">
			                        	<li class="left">
			                                <ul class="like">
			                                        	<li class="facebook"><span>1.5k</span></li>
			                                        	<li class="twitter"><span>&ensp;900</span></li>
			                                        	<li class="github"><span>10</span></li>
			                                </ul>
			                            </li>
			                            <li class="read">
			                                <p><a href="<%=request.getContextPath()%>/rest/articles/html">Read</a></p>
			                                <span><a href="http://">Save for Later</a></span>
			                            </li>
			                        </ul>
			                    </td>
		                   </tr>
				          </c:otherwise>
			          </c:choose> 
                 </c:forEach>
              </tbody>
            </table>
            <span class="paginationLink">
              <span class="left paginationInfo">
                 <c:out value="${it.pagination.start+1}"/> -
                  <c:out value="${it.pagination.start+it.pagination.limit}"/>
                  &nbsp; of <c:out value="${it.total}"/> &nbsp;&nbsp; Articles
              </span>
              <span class="right">
				  <c:if test="${it.pagination.start!=0}">
					<a href="<%=request.getContextPath()%>/rest/articles/list?limit=${it.pagination.limit}&start=${it.pagination.start-it.pagination.limit}">&nbsp;Prev&nbsp;&nbsp;</a>
				  </c:if>
				  <c:if test="${it.total-it.pagination.start-it.pagination.limit>0}">	
					<a href="<%=request.getContextPath()%>/rest/articles/list?limit=${it.pagination.limit}&start=${it.pagination.start+it.pagination.limit}">&nbsp;&nbsp;Next&nbsp;</a>
			      </c:if>
			 </span>
            </span>
        </div>
        <div class="link">
            <div id="footer">
	    		<div class="region region-footer">
		       </div>
	       </div>        
        </div>
</body>
</html>