package com.parse.web.resource.impl;

import java.util.HashMap;
import java.util.Map;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.parse.web.beans.Article;
import com.parse.web.beans.Pagination;
import com.parse.web.beans.RestResponse;
import com.parse.web.service.ArticleService;
import com.sun.jersey.api.view.Viewable;

@Component
@Path("/articles")
@Consumes(MediaType.APPLICATION_JSON)
@Produces(MediaType.APPLICATION_JSON)
public class ArticleResource {
   
	@Autowired
	private ArticleService articleService ;
	
	@GET
	@Path("/html")
	@Consumes({MediaType.APPLICATION_FORM_URLENCODED})
	@Produces({MediaType.TEXT_HTML})
	public Response showScreen() throws Exception {
	  return Response.ok(new Viewable("/WEB-INF/secured/articles.jsp", null)).build();
	}
	
	@GET
	@Path("/list")
	@Consumes({MediaType.APPLICATION_FORM_URLENCODED})
	@Produces({MediaType.TEXT_HTML})
	public Response getArticles (@QueryParam("limit") String limit,@QueryParam ("start") String start) throws Exception{
		Pagination pagination = new Pagination(limit,start);
		RestResponse<Article> articleResponse = articleService.getAllArticles(pagination);
		Map<String,Object> responseAttribute = new HashMap<String,Object>();
		responseAttribute.put("articles", articleResponse.getResults());
		responseAttribute.put("pagination", pagination);
		responseAttribute.put("total", articleResponse.getCount());
		return Response.ok(new Viewable("/WEB-INF/secured/home.jsp", responseAttribute)).build();
	}
	
}
