package com.parse.web.resource.impl;

import java.util.HashMap;
import java.util.Map;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.parse.web.beans.Article;
import com.parse.web.beans.Pagination;
import com.parse.web.beans.RestResponse;
import com.parse.web.service.CategoryService;
import com.sun.jersey.api.view.Viewable;

@Component
@Path("/categories")
@Consumes(MediaType.APPLICATION_JSON)
@Produces(MediaType.APPLICATION_JSON)
public class CategoryResource {

	@Autowired
	private CategoryService categoryService;

	@POST
	@Path("/save")
	public String save() throws Exception {
	   categoryService.save();
	   return "hello";
	}
	
	
	@GET
	@Path("/list")
	@Consumes({MediaType.APPLICATION_FORM_URLENCODED})
	@Produces({MediaType.TEXT_HTML})
	public Response categoryList(@QueryParam("limit") String limit,@QueryParam ("start") String start) throws Exception {
	  Map<String,Object> responseAttribute = new HashMap<String,Object>();
	  responseAttribute.put("categories", categoryService.fetchAllCategories(new Pagination(limit,start)));
	  return Response.ok(new Viewable("/WEB-INF/secured/categories.jsp", responseAttribute)).build();
	}
	
	@GET
	@Path("/home")
	@Consumes({MediaType.APPLICATION_FORM_URLENCODED})
	@Produces({MediaType.TEXT_HTML})
	public Response categoryHome(@QueryParam(value="categoryId") String categoryId) throws Exception{
		RestResponse<Article> restResponse = categoryService.fetchCategoryById(categoryId);
		Map<String, Object> responseAttribute = new HashMap<String, Object>();
		responseAttribute.put("articles", restResponse.getResults());
		responseAttribute.put("total",restResponse.getCount());
		return Response.ok(new Viewable("/WEB-INF/secured/categoriesHome.jsp",responseAttribute)).build();
	}
	
}
