package com.parse.web.resource.impl;

import java.util.HashMap;
import java.util.Map;

import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.parse.web.beans.Article;
import com.parse.web.beans.Pagination;
import com.parse.web.beans.RestResponse;
import com.parse.web.beans.UserCredential;
import com.parse.web.service.ArticleService;
import com.parse.web.service.LoginService;
import com.sun.jersey.api.view.Viewable;

@Component
@Path("/security")
@Consumes({ MediaType.APPLICATION_FORM_URLENCODED })
@Produces({ MediaType.TEXT_HTML })
public class LoginResource {

	@Autowired
	private LoginService loginService;

	@Autowired
	private ArticleService articleService;

	@POST
	@Path("/validateLogin")
	public Response validateLogin(UserCredential credentials) throws Exception {
		Pagination pagination = new Pagination();
		pagination.setLimit(50);
		pagination.setStart(0);
		RestResponse<Article> restResponse = articleService.getAllArticles(pagination);
		Map<String,Object> responseAttribute = new HashMap<String,Object>();
		responseAttribute.put("articles", restResponse.getResults());
		responseAttribute.put("pagination", pagination);
		responseAttribute.put("total", restResponse.getCount());
		return Response.ok(new Viewable("/WEB-INF/secured/home.jsp", responseAttribute)).build();
	}

}
