package com.parse.web.rest;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;

import javax.ws.rs.Consumes;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.ext.Provider;

import org.springframework.beans.BeanWrapper;
import org.springframework.beans.BeanWrapperImpl;

import com.sun.jersey.api.representation.Form;
import com.sun.jersey.core.impl.provider.entity.BaseFormProvider;
import com.sun.jersey.core.provider.AbstractMessageReaderWriterProvider;

@Provider
@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
public class FormSerializableProvider extends
		AbstractMessageReaderWriterProvider<Object> {

	private BaseFormProvider<MultivaluedMap<String, String>> bfp = new BaseFormProvider<MultivaluedMap<String, String>>() {

		@Override
		public boolean isReadable(Class<?> clazz, Type type,
				Annotation[] annotations, MediaType mt) {
			return false;
		}

		@Override
		public MultivaluedMap<String, String> readFrom(
				Class<MultivaluedMap<String, String>> type, Type genericType,
				Annotation[] annotation, MediaType mt,
				MultivaluedMap<String, String> headers, InputStream entityStream)
				throws IOException, WebApplicationException {
			return null;
		}

		@Override
		public boolean isWriteable(Class<?> clazz, Type t,
				Annotation[] annotation, MediaType mt) {
			return false;
		}

		@Override
		public void writeTo(MultivaluedMap<String, String> mvm, Class<?> clazz,
				Type type, Annotation[] annotation, MediaType mt,
				MultivaluedMap<String, Object> headers, OutputStream os)
				throws IOException, WebApplicationException {

		}
	};

	@Override
	public boolean isReadable(Class<?> clazz, Type type,
			Annotation[] annotation, MediaType mt) {
		return true;
	}

	@Override
	public Object readFrom(Class<Object> clazz, Type type,
			Annotation[] annotation, MediaType mediaType,
			MultivaluedMap<String, String> httpHeaders, InputStream entityStream)
			throws IOException, WebApplicationException {
		BeanWrapper bw = new BeanWrapperImpl(clazz);
		MultivaluedMap<String, String> mv = bfp.readFrom(new Form(), mediaType,entityStream);
		Iterator<Entry<String, List<String>>> i = mv.entrySet().iterator();
		while (i.hasNext()) {
			Entry<String, List<String>> e = i.next();
			if (e.getValue().size() > 0) {
				bw.setPropertyValue(e.getKey(), e.getValue().get(0));
			}
		}
		return bw.getWrappedInstance();
	}

	@Override
	public boolean isWriteable(Class<?> clazz, Type type,
			Annotation[] annotations, MediaType mt) {
		return false;
	}

	@Override
	public void writeTo(Object value, Class<?> c, Type type,
			Annotation[] annotation, MediaType mediaType,
			MultivaluedMap<String, Object> mvm, OutputStream os)
			throws IOException, WebApplicationException {

	}

}
