package com.parse.web.rest;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.lang.annotation.Annotation;
import java.lang.reflect.Type;

import javax.ws.rs.Consumes;
import javax.ws.rs.Produces;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.ext.Provider;

import com.sun.jersey.core.provider.AbstractMessageReaderWriterProvider;

@Provider
@Consumes("application/java")
@Produces("application/java")
public class JavaSerializableProvider extends AbstractMessageReaderWriterProvider<Object>{

	@Override
	public boolean isReadable(Class<?> clazz, Type type, Annotation[] annotation,
			MediaType mt) {
		return "java".equals(mt.getSubtype()) && clazz instanceof Serializable;
	}

	@Override
	public Object readFrom(Class<Object> value, Type type, Annotation[] annotation,
			MediaType mediaType, MultivaluedMap<String, String> mvm,
			InputStream is) throws IOException, WebApplicationException {
		ObjectInputStream ois = new ObjectInputStream(is);
        try{
        	return ois.readObject();
        }catch(Exception e){
    		return null;
        }
		
	}

	@Override
	public boolean isWriteable(Class<?> clazz, Type type, Annotation[] annotation,
			MediaType mediaType) {
		return clazz instanceof Serializable;
	}

	@Override
	public void writeTo(Object value, Class<?> clazz, Type type,
			Annotation[] annotation, MediaType mediaType,
			MultivaluedMap<String, Object> httpHeaders, OutputStream entityStream)
			throws IOException, WebApplicationException {
		ObjectOutputStream oos = new ObjectOutputStream(entityStream);
		oos.writeObject(value);
	}

}
