package com.parse.web.rest;

import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

import org.apache.log4j.Logger;
import org.codehaus.jackson.map.DeserializationConfig;
import org.codehaus.jackson.map.ObjectMapper;
import org.codehaus.jackson.map.SerializationConfig;
import org.codehaus.jackson.map.annotate.JsonSerialize;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;
import com.sun.jersey.client.urlconnection.HTTPSProperties;

public class RestClient  {
    
	private Logger logger = Logger.getLogger(RestClient.class);
	
	public Client createInstance() throws NoSuchAlgorithmException, KeyManagementException {
		logger.info("Initialising Singleton Jersey Client Object .. ");
		TrustManager trm = new X509TrustManager() {
			public X509Certificate[] getAcceptedIssuers() {
				return null;
			}

			@Override
			public void checkClientTrusted(X509Certificate[] chain,String authType) throws CertificateException {

			}

			@Override
			public void checkServerTrusted(X509Certificate[] chain,String authType) throws CertificateException {

			}
		};
		ClientConfig config = new DefaultClientConfig();
		SSLContext ctx = SSLContext.getInstance("SSL");
		ctx.init(null, new TrustManager[] { trm }, null);
		config.getProperties().put(HTTPSProperties.PROPERTY_HTTPS_PROPERTIES,new HTTPSProperties(null, ctx));
		Client client = Client.create(config);
		logger.info("Initialization completed for Jersey Client Object .. ");
		return client;
	}
	
	public ObjectMapper getMapperInstance() throws Exception{
		ObjectMapper objectMapper = new ObjectMapper();
		objectMapper.configure(SerializationConfig.Feature.USE_ANNOTATIONS, true);
		objectMapper.configure(DeserializationConfig.Feature.FAIL_ON_UNKNOWN_PROPERTIES, false);
		objectMapper.getSerializationConfig().setSerializationInclusion(JsonSerialize.Inclusion.NON_NULL);
		return objectMapper;
	}
}
