package com.parse.web.service.impl;

import static com.parse.web.util.Constants.*;
import java.io.Serializable;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.StringUtils;

import com.parse.web.beans.Pagination;


public class BaseService implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3428726958029688306L;
	private String applicationId;
	private String apiKey;

	public String getApplicationId() {
		return applicationId;
	}

	@Value("${parse.APPLICATION_ID}")
	public void setApplicationId(String applicationId) {
		this.applicationId = applicationId;
	}

	public String getApiKey() {
		return apiKey;
	}

	@Value("${parse.REST_API_KEY}")
	public void setApiKey(String apiKey) {
		this.apiKey = apiKey;
	}
	
	public String getPaginationLimit(Pagination pagination){
		if(pagination!= null && pagination.getLimit()!=null){
			return pagination.getLimit().toString();
		}
		return PAGINATION_DEFAULT;
	}
	
	public String getPaginationStart(Pagination pagination){
		if(pagination!= null && pagination.getStart()!=null){
			return pagination.getStart().toString();
		}
		return FIRST;
	}

	public String makeJsonCompatible(String json){
		if(StringUtils.hasText(json)){
			json = json.replaceFirst("^\\{\"results\":", "");
			json = json.replaceAll("\\}$", "");
		}
		return json;
	}
	
}
