package com.parse.web.service.impl;

import java.io.IOException;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;

import javax.ws.rs.core.MediaType;

import org.codehaus.jackson.JsonGenerationException;
import org.codehaus.jackson.map.JsonMappingException;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.parse.web.beans.Article;
import com.parse.web.beans.LoginResponse;
import com.parse.web.beans.UserCredential;
import com.parse.web.service.LoginService;
import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;

@Service(value="loginService")
public class LoginServiceImpl  extends BaseService implements LoginService{

	/**
	 * 
	 */
	private static final long serialVersionUID = 5923610013705664028L;
	
	@Autowired
	private Client client ;
    
	@Override
	public LoginResponse validateLogin(UserCredential credetials) throws Exception {
		WebResource webResource = client.resource("https://api.parse.com/1/classes/Singer");
		ClientResponse response = webResource.type("application/json")
					               .header("X-Parse-Application-ID", getApplicationId())
					               .header("X-Parse-REST-API-Key", getApiKey())
					               .post(ClientResponse.class, "\\{\"singer\":\"Metallica\",\"title\":\"Fade To Black\"}");
		String output = response.getEntity(String.class);
		System.out.println(output);
		UserCredential userCredential = new UserCredential();
		userCredential.setApplication("facebook");
		userCredential.setPassword("abc123");
		userCredential.setUserName("userName..");
		
		ObjectMapper objectMapper = new ObjectMapper();
		System.out.println(objectMapper.writeValueAsString(userCredential));
		
		return null;
	}
	
	@Override
	public void testParse() throws Exception{
//		WebResource webResource = client.resource("https://api.parse.com/1/classes/Singer");
//		ClientResponse clntResponse = webResource.path("xzhUkmfJdx")
//			                           .type("application/json")
//						               .header("X-Parse-Application-ID", getApplicationId())
//						               .header("X-Parse-REST-API-Key", getApiKey())
//						               .accept(MediaType.APPLICATION_JSON)
//						               .put(ClientResponse.class,"{\"pointerTest\":{\"__type\":\"Pointer\",\"className\":\"Concerts\",\"objectId\":\"2JO7Mvlg8t\"}}");
//		
//		String response = clntResponse.getEntity(String.class);
//		System.out.println(response);
//		
////		ObjectMapper objectMapper = new ObjectMapper();
////		Singer singer = objectMapper.readValue(response, Singer.class);
////		System.out.println("**************"+singer.getSinger());
//		
////		Singer singer = new Singer();
////		singer.setSinger("MJ Second");
////		singer.setTitle("Moon Walk  Second");
//	
//		/**
//		 * Adding second table
//		 */
////		WebResource webResource = client.resource("https://api.parse.com/1/classes/Concerts");
////		ClientResponse response = webResource.type("application/json")
////					               .header("X-Parse-Application-ID", getApplicationId())
////					               .header("X-Parse-REST-API-Key", getApiKey())
////					               .post(ClientResponse.class, "{\"location\":\"New Jersey\",\"type\":\"Group\"}");
////		String output = response.getEntity(String.class);
////		System.out.println(output);
//		
//		/**
//		 * Simple Where clause test
//		 */
//	    webResource = client.resource("https://api.parse.com/1/classes/Singer/xzhUkmfJdx")
//		                          .queryParam("include", "pointerTest");
//		ClientResponse clntresponse = webResource.type(MediaType.APPLICATION_FORM_URLENCODED)
//					               .header("X-Parse-Application-ID", getApplicationId())
//					               .header("X-Parse-REST-API-Key", getApiKey())
//					               .get(ClientResponse.class);
//		String output = clntresponse.getEntity(String.class);
//		System.out.println(output);
		//populateTest();
	}
	
	public void populateTest() throws KeyManagementException, NoSuchAlgorithmException, JsonGenerationException, JsonMappingException, IOException{
		WebResource webResource = client.resource("https://api.parse.com/1/classes/Article");
		for (int i =2; i < 151 ;i++){
			Article article = new Article();
			article.setTitle("ARTICLE_"+i);
			article.setDescription("ARTICLE_"+i);
			ObjectMapper objectMapper = new ObjectMapper();
			String request = objectMapper.writeValueAsString(article);
			System.out.println(request);
			ClientResponse clntResponse = webResource.type(MediaType.APPLICATION_JSON)
	        .header("X-Parse-Application-ID",getApplicationId())
	        .header("X-Parse-REST-API-Key", getApiKey())
			.post(ClientResponse.class,request);
			System.out.println(clntResponse.getEntity(String.class));
		}
	}

}
